// stack_list.h
//
// Implementiert die Stack-Basisklasse mit einer Liste.
//
// Informatik 1 D-ITET
// Musterloesung Uebung 13
// 
// Nicky Kern, 30.1.2002

#ifndef _STACK_LIST_H
#define _STACK_LIST_H

#include "stack.h"

class ListStack :
	public Stack
{
public:
	ListStack();

	bool push(char c);
	bool pop(char& c);
	bool is_empty();
	bool is_full();

private:
	// This is a private class of ListStack.
	// It is kept private, because ListStack is the only class, that uses it.
	// Therefore there is no reason to declare it separatly and thus make it
	// visible outside of ListStack.
	// Since it is declared in the private-section, only ListStack can create
	// objects of the StackItem-class, i.e. neither code outside ListStack nor
	// derived classes can access StackItem.
	class StackItem
	{
	public:
		StackItem(char c2, StackItem* n) 
		{
			c = c2;
			next = n;
		}

		char c;
		StackItem *next;
	};

	StackItem *front;
};

#endif
