// main.cpp
//
// Informatik 1 D-ITET
// 
// Uebung 12 Musterloesung
// 
// Nicky Kern, 30.1.2002

#include "stack_array.h"
#include "stack_list.h"

#include <string>

bool isPalindrom(char *s, Stack &st) 
{
	// 1. step: insert all the characters into the stack
	for (unsigned i=0; i<strlen(s); i++) 
          {
		if (! isalpha(s[i])) continue;
		if (!st.push(tolower(s[i]))) 
                  {
                    cout << "Stack full! Giving up!" << endl;
                    return false;
                  }
          }

	// 2. step: compare all characters to the ones from the stack
	for (unsigned i=0; i<strlen(s); i++) 
          {
            if (! isalpha(s[i])) continue;

            char c;
            if (! st.pop(c)) 
              {
                cout << "Error in Stack! Shouldn't happen! Giving up!" << endl;
                return false;
              }

            if (c != tolower(s[i])) 
              {
                return false;
              }
          }

	return true;
}

int main(int argc, char** argv)
{
  cout << "Palindrom Tester by Nicky Kern (c) 2002" << endl;
  if (argc != 2) 
    { 
      cout << "Usage: palindrom \"test-string\"" << endl;
      return 0;
    }

  // 1. Try: use the Array variant
  // The array is computationally very simple and efficient. However, its
  // length is inherently limited, which might be problematic in certain
  // circumstances...
  ArrayStack st1; 
  cout << endl << "Using an array" << endl;
  if (isPalindrom(argv[1], st1)) 
    {
      cout << "'" << argv[1] << "' is a palindrom" << endl;
    } 
  else 
    {
      cout << "'" << argv[1] << "' is not a palindrom" << endl;
    }

  // 2. Try: use the list variant
  // The list is better if an unlimited length of the stack is required.
  // However, it is more expensive in terms of computation, so when little
  // computation power is available, an array might be preferred.
  ListStack st2; 
  cout << endl << "Using a list" << endl;
  if (isPalindrom(argv[1], st2)) 
    {
      cout << "'" << argv[1] << "' is a palindrom" << endl;
    } 
  else 
    {
      cout << "'" << argv[1] << "' is not a palindrom" << endl;
    }
}
